// Telegrammer - Telegram Bot Swift SDK.
// This file is autogenerated by API/generate_wrappers.rb script.

/**
 This object represents an incoming inline query. When the user sends an empty query, your bot could return some default or trending results.

 SeeAlso Telegram Bot API Reference:
 [InlineQuery](https://core.telegram.org/bots/api#inlinequery)
 */
public final class InlineQuery: Codable {

    /// Custom keys for coding/decoding `InlineQuery` struct
    enum CodingKeys: String, CodingKey {
        case id = "id"
        case from = "from"
        case location = "location"
        case query = "query"
        case offset = "offset"
    }

    /// Unique identifier for this query
    public var id: String

    /// Sender
    public var from: User

    /// Optional. Sender location, only for bots that request user location
    public var location: Location?

    /// Text of the query (up to 512 characters)
    public var query: String

    /// Offset of the results to be returned, can be controlled by the bot
    public var offset: String


    public init (id: String, from: User, location: Location? = nil, query: String, offset: String) {
        self.id = id
        self.from = from
        self.location = location
        self.query = query
        self.offset = offset
    }
}
